// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/ManeuverConstraints.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONSTRAINTS__TRAITS_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONSTRAINTS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_constraints__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'maneuver_type'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_type__traits.hpp"
// Member 'longitudinal_maneuver_waypoint_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/longitudinal_maneuver_waypoint_container__traits.hpp"
// Member 'maneuver_corridor'
#include "etsi_its_mcm_uulm_msgs/msg/detail/polygon__traits.hpp"

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ManeuverConstraints & msg,
  std::ostream & out)
{
  out << "{";
  // member: maneuver_type
  {
    out << "maneuver_type: ";
    to_flow_style_yaml(msg.maneuver_type, out);
    out << ", ";
  }

  // member: maneuver_type_is_present
  {
    out << "maneuver_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.maneuver_type_is_present, out);
    out << ", ";
  }

  // member: longitudinal_maneuver_waypoint_container
  {
    out << "longitudinal_maneuver_waypoint_container: ";
    to_flow_style_yaml(msg.longitudinal_maneuver_waypoint_container, out);
    out << ", ";
  }

  // member: maneuver_corridor
  {
    out << "maneuver_corridor: ";
    to_flow_style_yaml(msg.maneuver_corridor, out);
    out << ", ";
  }

  // member: maneuver_corridor_is_present
  {
    out << "maneuver_corridor_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.maneuver_corridor_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ManeuverConstraints & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: maneuver_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuver_type:\n";
    to_block_style_yaml(msg.maneuver_type, out, indentation + 2);
  }

  // member: maneuver_type_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuver_type_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.maneuver_type_is_present, out);
    out << "\n";
  }

  // member: longitudinal_maneuver_waypoint_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "longitudinal_maneuver_waypoint_container:\n";
    to_block_style_yaml(msg.longitudinal_maneuver_waypoint_container, out, indentation + 2);
  }

  // member: maneuver_corridor
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuver_corridor:\n";
    to_block_style_yaml(msg.maneuver_corridor, out, indentation + 2);
  }

  // member: maneuver_corridor_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuver_corridor_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.maneuver_corridor_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ManeuverConstraints & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints & msg)
{
  return etsi_its_mcm_uulm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints>()
{
  return "etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints";
}

template<>
inline const char * name<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints>()
{
  return "etsi_its_mcm_uulm_msgs/msg/ManeuverConstraints";
}

template<>
struct has_fixed_size<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mcm_uulm_msgs::msg::LongitudinalManeuverWaypointContainer>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::ManeuverType>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::Polygon>::value> {};

template<>
struct has_bounded_size<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mcm_uulm_msgs::msg::LongitudinalManeuverWaypointContainer>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::ManeuverType>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::Polygon>::value> {};

template<>
struct is_message<etsi_its_mcm_uulm_msgs::msg::ManeuverConstraints>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_CONSTRAINTS__TRAITS_HPP_
