// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mcm_uulm_msgs:msg/ManeuverParameters.idl
// generated code does not contain a copyright notice
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_parameters__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `maneuver_constraints`
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_constraints__functions.h"
// Member `termination_status`
#include "etsi_its_mcm_uulm_msgs/msg/detail/termination_status__functions.h"

bool
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__init(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters * msg)
{
  if (!msg) {
    return false;
  }
  // choice
  // maneuver_constraints
  if (!etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__init(&msg->maneuver_constraints)) {
    etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__fini(msg);
    return false;
  }
  // termination_status
  if (!etsi_its_mcm_uulm_msgs__msg__TerminationStatus__init(&msg->termination_status)) {
    etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__fini(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters * msg)
{
  if (!msg) {
    return;
  }
  // choice
  // maneuver_constraints
  etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__fini(&msg->maneuver_constraints);
  // termination_status
  etsi_its_mcm_uulm_msgs__msg__TerminationStatus__fini(&msg->termination_status);
}

bool
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__are_equal(const etsi_its_mcm_uulm_msgs__msg__ManeuverParameters * lhs, const etsi_its_mcm_uulm_msgs__msg__ManeuverParameters * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // choice
  if (lhs->choice != rhs->choice) {
    return false;
  }
  // maneuver_constraints
  if (!etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__are_equal(
      &(lhs->maneuver_constraints), &(rhs->maneuver_constraints)))
  {
    return false;
  }
  // termination_status
  if (!etsi_its_mcm_uulm_msgs__msg__TerminationStatus__are_equal(
      &(lhs->termination_status), &(rhs->termination_status)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__copy(
  const etsi_its_mcm_uulm_msgs__msg__ManeuverParameters * input,
  etsi_its_mcm_uulm_msgs__msg__ManeuverParameters * output)
{
  if (!input || !output) {
    return false;
  }
  // choice
  output->choice = input->choice;
  // maneuver_constraints
  if (!etsi_its_mcm_uulm_msgs__msg__ManeuverConstraints__copy(
      &(input->maneuver_constraints), &(output->maneuver_constraints)))
  {
    return false;
  }
  // termination_status
  if (!etsi_its_mcm_uulm_msgs__msg__TerminationStatus__copy(
      &(input->termination_status), &(output->termination_status)))
  {
    return false;
  }
  return true;
}

etsi_its_mcm_uulm_msgs__msg__ManeuverParameters *
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__ManeuverParameters * msg = (etsi_its_mcm_uulm_msgs__msg__ManeuverParameters *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters));
  bool success = etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__destroy(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence__init(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__ManeuverParameters * data = NULL;

  if (size) {
    data = (etsi_its_mcm_uulm_msgs__msg__ManeuverParameters *)allocator.zero_allocate(size, sizeof(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence__fini(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence *
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence * array = (etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence__destroy(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence__are_equal(const etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence * lhs, const etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence__copy(
  const etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence * input,
  etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mcm_uulm_msgs__msg__ManeuverParameters);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mcm_uulm_msgs__msg__ManeuverParameters * data =
      (etsi_its_mcm_uulm_msgs__msg__ManeuverParameters *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__ManeuverParameters__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
