// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mcm_uulm_msgs:msg/McmParameters.idl
// generated code does not contain a copyright notice
#include "etsi_its_mcm_uulm_msgs/msg/detail/mcm_parameters__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `basic_container`
#include "etsi_its_mcm_uulm_msgs/msg/detail/basic_container__functions.h"
// Member `maneuver_container`
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_container__functions.h"

bool
etsi_its_mcm_uulm_msgs__msg__McmParameters__init(etsi_its_mcm_uulm_msgs__msg__McmParameters * msg)
{
  if (!msg) {
    return false;
  }
  // basic_container
  if (!etsi_its_mcm_uulm_msgs__msg__BasicContainer__init(&msg->basic_container)) {
    etsi_its_mcm_uulm_msgs__msg__McmParameters__fini(msg);
    return false;
  }
  // maneuver_container
  if (!etsi_its_mcm_uulm_msgs__msg__ManeuverContainer__init(&msg->maneuver_container)) {
    etsi_its_mcm_uulm_msgs__msg__McmParameters__fini(msg);
    return false;
  }
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__McmParameters__fini(etsi_its_mcm_uulm_msgs__msg__McmParameters * msg)
{
  if (!msg) {
    return;
  }
  // basic_container
  etsi_its_mcm_uulm_msgs__msg__BasicContainer__fini(&msg->basic_container);
  // maneuver_container
  etsi_its_mcm_uulm_msgs__msg__ManeuverContainer__fini(&msg->maneuver_container);
}

bool
etsi_its_mcm_uulm_msgs__msg__McmParameters__are_equal(const etsi_its_mcm_uulm_msgs__msg__McmParameters * lhs, const etsi_its_mcm_uulm_msgs__msg__McmParameters * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // basic_container
  if (!etsi_its_mcm_uulm_msgs__msg__BasicContainer__are_equal(
      &(lhs->basic_container), &(rhs->basic_container)))
  {
    return false;
  }
  // maneuver_container
  if (!etsi_its_mcm_uulm_msgs__msg__ManeuverContainer__are_equal(
      &(lhs->maneuver_container), &(rhs->maneuver_container)))
  {
    return false;
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__McmParameters__copy(
  const etsi_its_mcm_uulm_msgs__msg__McmParameters * input,
  etsi_its_mcm_uulm_msgs__msg__McmParameters * output)
{
  if (!input || !output) {
    return false;
  }
  // basic_container
  if (!etsi_its_mcm_uulm_msgs__msg__BasicContainer__copy(
      &(input->basic_container), &(output->basic_container)))
  {
    return false;
  }
  // maneuver_container
  if (!etsi_its_mcm_uulm_msgs__msg__ManeuverContainer__copy(
      &(input->maneuver_container), &(output->maneuver_container)))
  {
    return false;
  }
  return true;
}

etsi_its_mcm_uulm_msgs__msg__McmParameters *
etsi_its_mcm_uulm_msgs__msg__McmParameters__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__McmParameters * msg = (etsi_its_mcm_uulm_msgs__msg__McmParameters *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__McmParameters), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mcm_uulm_msgs__msg__McmParameters));
  bool success = etsi_its_mcm_uulm_msgs__msg__McmParameters__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mcm_uulm_msgs__msg__McmParameters__destroy(etsi_its_mcm_uulm_msgs__msg__McmParameters * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mcm_uulm_msgs__msg__McmParameters__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence__init(etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__McmParameters * data = NULL;

  if (size) {
    data = (etsi_its_mcm_uulm_msgs__msg__McmParameters *)allocator.zero_allocate(size, sizeof(etsi_its_mcm_uulm_msgs__msg__McmParameters), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mcm_uulm_msgs__msg__McmParameters__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mcm_uulm_msgs__msg__McmParameters__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence__fini(etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mcm_uulm_msgs__msg__McmParameters__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence *
etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence * array = (etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence__destroy(etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence__are_equal(const etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence * lhs, const etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__McmParameters__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence__copy(
  const etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence * input,
  etsi_its_mcm_uulm_msgs__msg__McmParameters__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mcm_uulm_msgs__msg__McmParameters);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mcm_uulm_msgs__msg__McmParameters * data =
      (etsi_its_mcm_uulm_msgs__msg__McmParameters *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mcm_uulm_msgs__msg__McmParameters__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mcm_uulm_msgs__msg__McmParameters__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__McmParameters__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
