// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/McmParameters.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MCM_PARAMETERS__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MCM_PARAMETERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'basic_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/basic_container__struct.hpp"
// Member 'maneuver_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_container__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__McmParameters __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__McmParameters __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct McmParameters_
{
  using Type = McmParameters_<ContainerAllocator>;

  explicit McmParameters_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : basic_container(_init),
    maneuver_container(_init)
  {
    (void)_init;
  }

  explicit McmParameters_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : basic_container(_alloc, _init),
    maneuver_container(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _basic_container_type =
    etsi_its_mcm_uulm_msgs::msg::BasicContainer_<ContainerAllocator>;
  _basic_container_type basic_container;
  using _maneuver_container_type =
    etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator>;
  _maneuver_container_type maneuver_container;

  // setters for named parameter idiom
  Type & set__basic_container(
    const etsi_its_mcm_uulm_msgs::msg::BasicContainer_<ContainerAllocator> & _arg)
  {
    this->basic_container = _arg;
    return *this;
  }
  Type & set__maneuver_container(
    const etsi_its_mcm_uulm_msgs::msg::ManeuverContainer_<ContainerAllocator> & _arg)
  {
    this->maneuver_container = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__McmParameters
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__McmParameters
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const McmParameters_ & other) const
  {
    if (this->basic_container != other.basic_container) {
      return false;
    }
    if (this->maneuver_container != other.maneuver_container) {
      return false;
    }
    return true;
  }
  bool operator!=(const McmParameters_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct McmParameters_

// alias to use template instance with default allocator
using McmParameters =
  etsi_its_mcm_uulm_msgs::msg::McmParameters_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MCM_PARAMETERS__STRUCT_HPP_
