// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/RoadUserContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'road_user_state'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_state__traits.hpp"
// Member 'planned_trajectory'
#include "etsi_its_mcm_uulm_msgs/msg/detail/planned_trajectory__traits.hpp"
// Member 'desired_route'
#include "etsi_its_mcm_uulm_msgs/msg/detail/desired_route__traits.hpp"
// Member 'advice_response'
#include "etsi_its_mcm_uulm_msgs/msg/detail/advice_response__traits.hpp"

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RoadUserContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: road_user_state
  {
    out << "road_user_state: ";
    to_flow_style_yaml(msg.road_user_state, out);
    out << ", ";
  }

  // member: planned_trajectory
  {
    out << "planned_trajectory: ";
    to_flow_style_yaml(msg.planned_trajectory, out);
    out << ", ";
  }

  // member: planned_trajectory_is_present
  {
    out << "planned_trajectory_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.planned_trajectory_is_present, out);
    out << ", ";
  }

  // member: desired_route
  {
    out << "desired_route: ";
    to_flow_style_yaml(msg.desired_route, out);
    out << ", ";
  }

  // member: desired_route_is_present
  {
    out << "desired_route_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.desired_route_is_present, out);
    out << ", ";
  }

  // member: advice_response
  {
    out << "advice_response: ";
    to_flow_style_yaml(msg.advice_response, out);
    out << ", ";
  }

  // member: advice_response_is_present
  {
    out << "advice_response_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.advice_response_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RoadUserContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: road_user_state
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_user_state:\n";
    to_block_style_yaml(msg.road_user_state, out, indentation + 2);
  }

  // member: planned_trajectory
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "planned_trajectory:\n";
    to_block_style_yaml(msg.planned_trajectory, out, indentation + 2);
  }

  // member: planned_trajectory_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "planned_trajectory_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.planned_trajectory_is_present, out);
    out << "\n";
  }

  // member: desired_route
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "desired_route:\n";
    to_block_style_yaml(msg.desired_route, out, indentation + 2);
  }

  // member: desired_route_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "desired_route_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.desired_route_is_present, out);
    out << "\n";
  }

  // member: advice_response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "advice_response:\n";
    to_block_style_yaml(msg.advice_response, out, indentation + 2);
  }

  // member: advice_response_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "advice_response_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.advice_response_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RoadUserContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mcm_uulm_msgs::msg::RoadUserContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mcm_uulm_msgs::msg::RoadUserContainer & msg)
{
  return etsi_its_mcm_uulm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer>()
{
  return "etsi_its_mcm_uulm_msgs::msg::RoadUserContainer";
}

template<>
inline const char * name<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer>()
{
  return "etsi_its_mcm_uulm_msgs/msg/RoadUserContainer";
}

template<>
struct has_fixed_size<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mcm_uulm_msgs::msg::AdviceResponse>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::DesiredRoute>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::PlannedTrajectory>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::RoadUserState>::value> {};

template<>
struct has_bounded_size<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mcm_uulm_msgs::msg::AdviceResponse>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::DesiredRoute>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::PlannedTrajectory>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::RoadUserState>::value> {};

template<>
struct is_message<etsi_its_mcm_uulm_msgs::msg::RoadUserContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_CONTAINER__TRAITS_HPP_
