// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_mcm_uulm_msgs:msg/RoadUserState.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_STATE__STRUCT_H_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_STATE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'road_user_type'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_type__struct.h"
// Member 'speed'
#include "etsi_its_mcm_uulm_msgs/msg/detail/speed_value__struct.h"
// Member 'heading'
#include "etsi_its_mcm_uulm_msgs/msg/detail/heading_value__struct.h"
// Member 'length'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_length__struct.h"
// Member 'width'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_width__struct.h"

/// Struct defined in msg/RoadUserState in the package etsi_its_mcm_uulm_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_mcm_uulm_msgs__msg__RoadUserState
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/patched/uulm_mcm_etsi/TS103561_LUKAS_MCM.asn
  ///   asn1/patched/uulm_mcm_etsi/ETSI-ITS-CDD.asn
  ///   -t
  ///   mcm_uulm
  ///   -o
  ///   etsi_its_msgs/etsi_its_mcm_uulm_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// RoadUserState ::= SEQUENCE {
  ///  roadUserType    RoadUserType,
  ///  speed           SpeedValue,
  ///  heading         HeadingValue,
  ///  length          RoadUserLength,
  ///  width           RoadUserWidth
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_mcm_uulm_msgs__msg__RoadUserType road_user_type;
  etsi_its_mcm_uulm_msgs__msg__SpeedValue speed;
  etsi_its_mcm_uulm_msgs__msg__HeadingValue heading;
  etsi_its_mcm_uulm_msgs__msg__RoadUserLength length;
  etsi_its_mcm_uulm_msgs__msg__RoadUserWidth width;
} etsi_its_mcm_uulm_msgs__msg__RoadUserState;

// Struct for a sequence of etsi_its_mcm_uulm_msgs__msg__RoadUserState.
typedef struct etsi_its_mcm_uulm_msgs__msg__RoadUserState__Sequence
{
  etsi_its_mcm_uulm_msgs__msg__RoadUserState * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_mcm_uulm_msgs__msg__RoadUserState__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_STATE__STRUCT_H_
