// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/RoadUserState.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_STATE__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_STATE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'road_user_type'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_type__struct.hpp"
// Member 'speed'
#include "etsi_its_mcm_uulm_msgs/msg/detail/speed_value__struct.hpp"
// Member 'heading'
#include "etsi_its_mcm_uulm_msgs/msg/detail/heading_value__struct.hpp"
// Member 'length'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_length__struct.hpp"
// Member 'width'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_width__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__RoadUserState __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__RoadUserState __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadUserState_
{
  using Type = RoadUserState_<ContainerAllocator>;

  explicit RoadUserState_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_user_type(_init),
    speed(_init),
    heading(_init),
    length(_init),
    width(_init)
  {
    (void)_init;
  }

  explicit RoadUserState_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_user_type(_alloc, _init),
    speed(_alloc, _init),
    heading(_alloc, _init),
    length(_alloc, _init),
    width(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _road_user_type_type =
    etsi_its_mcm_uulm_msgs::msg::RoadUserType_<ContainerAllocator>;
  _road_user_type_type road_user_type;
  using _speed_type =
    etsi_its_mcm_uulm_msgs::msg::SpeedValue_<ContainerAllocator>;
  _speed_type speed;
  using _heading_type =
    etsi_its_mcm_uulm_msgs::msg::HeadingValue_<ContainerAllocator>;
  _heading_type heading;
  using _length_type =
    etsi_its_mcm_uulm_msgs::msg::RoadUserLength_<ContainerAllocator>;
  _length_type length;
  using _width_type =
    etsi_its_mcm_uulm_msgs::msg::RoadUserWidth_<ContainerAllocator>;
  _width_type width;

  // setters for named parameter idiom
  Type & set__road_user_type(
    const etsi_its_mcm_uulm_msgs::msg::RoadUserType_<ContainerAllocator> & _arg)
  {
    this->road_user_type = _arg;
    return *this;
  }
  Type & set__speed(
    const etsi_its_mcm_uulm_msgs::msg::SpeedValue_<ContainerAllocator> & _arg)
  {
    this->speed = _arg;
    return *this;
  }
  Type & set__heading(
    const etsi_its_mcm_uulm_msgs::msg::HeadingValue_<ContainerAllocator> & _arg)
  {
    this->heading = _arg;
    return *this;
  }
  Type & set__length(
    const etsi_its_mcm_uulm_msgs::msg::RoadUserLength_<ContainerAllocator> & _arg)
  {
    this->length = _arg;
    return *this;
  }
  Type & set__width(
    const etsi_its_mcm_uulm_msgs::msg::RoadUserWidth_<ContainerAllocator> & _arg)
  {
    this->width = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__RoadUserState
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__RoadUserState
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::RoadUserState_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadUserState_ & other) const
  {
    if (this->road_user_type != other.road_user_type) {
      return false;
    }
    if (this->speed != other.speed) {
      return false;
    }
    if (this->heading != other.heading) {
      return false;
    }
    if (this->length != other.length) {
      return false;
    }
    if (this->width != other.width) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadUserState_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadUserState_

// alias to use template instance with default allocator
using RoadUserState =
  etsi_its_mcm_uulm_msgs::msg::RoadUserState_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_STATE__STRUCT_HPP_
