// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/SuggestedManeuver.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'maneuver_id'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_id__struct.hpp"
// Member 'advice_update_id'
#include "etsi_its_mcm_uulm_msgs/msg/detail/advice_update_id__struct.hpp"
// Member 'participating_road_user_id_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/participating_road_user_id_container__struct.hpp"
// Member 'confirmation_required_flag'
#include "etsi_its_mcm_uulm_msgs/msg/detail/confirmation_required_flag__struct.hpp"
// Member 'maneuver_parameters'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_parameters__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SuggestedManeuver_
{
  using Type = SuggestedManeuver_<ContainerAllocator>;

  explicit SuggestedManeuver_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : maneuver_id(_init),
    advice_update_id(_init),
    participating_road_user_id_container(_init),
    confirmation_required_flag(_init),
    maneuver_parameters(_init)
  {
    (void)_init;
  }

  explicit SuggestedManeuver_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : maneuver_id(_alloc, _init),
    advice_update_id(_alloc, _init),
    participating_road_user_id_container(_alloc, _init),
    confirmation_required_flag(_alloc, _init),
    maneuver_parameters(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _maneuver_id_type =
    etsi_its_mcm_uulm_msgs::msg::ManeuverID_<ContainerAllocator>;
  _maneuver_id_type maneuver_id;
  using _advice_update_id_type =
    etsi_its_mcm_uulm_msgs::msg::AdviceUpdateID_<ContainerAllocator>;
  _advice_update_id_type advice_update_id;
  using _participating_road_user_id_container_type =
    etsi_its_mcm_uulm_msgs::msg::ParticipatingRoadUserIDContainer_<ContainerAllocator>;
  _participating_road_user_id_container_type participating_road_user_id_container;
  using _confirmation_required_flag_type =
    etsi_its_mcm_uulm_msgs::msg::ConfirmationRequiredFlag_<ContainerAllocator>;
  _confirmation_required_flag_type confirmation_required_flag;
  using _maneuver_parameters_type =
    etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator>;
  _maneuver_parameters_type maneuver_parameters;

  // setters for named parameter idiom
  Type & set__maneuver_id(
    const etsi_its_mcm_uulm_msgs::msg::ManeuverID_<ContainerAllocator> & _arg)
  {
    this->maneuver_id = _arg;
    return *this;
  }
  Type & set__advice_update_id(
    const etsi_its_mcm_uulm_msgs::msg::AdviceUpdateID_<ContainerAllocator> & _arg)
  {
    this->advice_update_id = _arg;
    return *this;
  }
  Type & set__participating_road_user_id_container(
    const etsi_its_mcm_uulm_msgs::msg::ParticipatingRoadUserIDContainer_<ContainerAllocator> & _arg)
  {
    this->participating_road_user_id_container = _arg;
    return *this;
  }
  Type & set__confirmation_required_flag(
    const etsi_its_mcm_uulm_msgs::msg::ConfirmationRequiredFlag_<ContainerAllocator> & _arg)
  {
    this->confirmation_required_flag = _arg;
    return *this;
  }
  Type & set__maneuver_parameters(
    const etsi_its_mcm_uulm_msgs::msg::ManeuverParameters_<ContainerAllocator> & _arg)
  {
    this->maneuver_parameters = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SuggestedManeuver_ & other) const
  {
    if (this->maneuver_id != other.maneuver_id) {
      return false;
    }
    if (this->advice_update_id != other.advice_update_id) {
      return false;
    }
    if (this->participating_road_user_id_container != other.participating_road_user_id_container) {
      return false;
    }
    if (this->confirmation_required_flag != other.confirmation_required_flag) {
      return false;
    }
    if (this->maneuver_parameters != other.maneuver_parameters) {
      return false;
    }
    return true;
  }
  bool operator!=(const SuggestedManeuver_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SuggestedManeuver_

// alias to use template instance with default allocator
using SuggestedManeuver =
  etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER__STRUCT_HPP_
