// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mcm_uulm_msgs:msg/LongitudinalWaypoint.idl
// generated code does not contain a copyright notice
#include "etsi_its_mcm_uulm_msgs/msg/detail/longitudinal_waypoint__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `waypoint`
#include "etsi_its_mcm_uulm_msgs/msg/detail/waypoint__functions.h"
// Member `min_arrival_time`
// Member `max_arrival_time`
// Member `min_duration_of_stop`
#include "etsi_its_mcm_uulm_msgs/msg/detail/waypoint_delta_time__functions.h"
// Member `min_velocity`
// Member `max_velocity`
#include "etsi_its_mcm_uulm_msgs/msg/detail/speed_value__functions.h"
// Member `preceding_road_user`
// Member `following_road_user`
#include "etsi_its_mcm_uulm_msgs/msg/detail/participating_road_user_index__functions.h"
// Member `yield_to_road_user_container`
#include "etsi_its_mcm_uulm_msgs/msg/detail/yield_to_road_user_container__functions.h"

bool
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__init(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * msg)
{
  if (!msg) {
    return false;
  }
  // waypoint
  if (!etsi_its_mcm_uulm_msgs__msg__Waypoint__init(&msg->waypoint)) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(msg);
    return false;
  }
  // min_arrival_time
  if (!etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__init(&msg->min_arrival_time)) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(msg);
    return false;
  }
  // max_arrival_time
  if (!etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__init(&msg->max_arrival_time)) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(msg);
    return false;
  }
  // min_velocity
  if (!etsi_its_mcm_uulm_msgs__msg__SpeedValue__init(&msg->min_velocity)) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(msg);
    return false;
  }
  // min_velocity_is_present
  // max_velocity
  if (!etsi_its_mcm_uulm_msgs__msg__SpeedValue__init(&msg->max_velocity)) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(msg);
    return false;
  }
  // max_velocity_is_present
  // min_duration_of_stop
  if (!etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__init(&msg->min_duration_of_stop)) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(msg);
    return false;
  }
  // min_duration_of_stop_is_present
  // preceding_road_user
  if (!etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIndex__init(&msg->preceding_road_user)) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(msg);
    return false;
  }
  // preceding_road_user_is_present
  // following_road_user
  if (!etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIndex__init(&msg->following_road_user)) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(msg);
    return false;
  }
  // following_road_user_is_present
  // yield_to_road_user_container
  if (!etsi_its_mcm_uulm_msgs__msg__YieldToRoadUserContainer__init(&msg->yield_to_road_user_container)) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(msg);
    return false;
  }
  // yield_to_road_user_container_is_present
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * msg)
{
  if (!msg) {
    return;
  }
  // waypoint
  etsi_its_mcm_uulm_msgs__msg__Waypoint__fini(&msg->waypoint);
  // min_arrival_time
  etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__fini(&msg->min_arrival_time);
  // max_arrival_time
  etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__fini(&msg->max_arrival_time);
  // min_velocity
  etsi_its_mcm_uulm_msgs__msg__SpeedValue__fini(&msg->min_velocity);
  // min_velocity_is_present
  // max_velocity
  etsi_its_mcm_uulm_msgs__msg__SpeedValue__fini(&msg->max_velocity);
  // max_velocity_is_present
  // min_duration_of_stop
  etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__fini(&msg->min_duration_of_stop);
  // min_duration_of_stop_is_present
  // preceding_road_user
  etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIndex__fini(&msg->preceding_road_user);
  // preceding_road_user_is_present
  // following_road_user
  etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIndex__fini(&msg->following_road_user);
  // following_road_user_is_present
  // yield_to_road_user_container
  etsi_its_mcm_uulm_msgs__msg__YieldToRoadUserContainer__fini(&msg->yield_to_road_user_container);
  // yield_to_road_user_container_is_present
}

bool
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__are_equal(const etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * lhs, const etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // waypoint
  if (!etsi_its_mcm_uulm_msgs__msg__Waypoint__are_equal(
      &(lhs->waypoint), &(rhs->waypoint)))
  {
    return false;
  }
  // min_arrival_time
  if (!etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__are_equal(
      &(lhs->min_arrival_time), &(rhs->min_arrival_time)))
  {
    return false;
  }
  // max_arrival_time
  if (!etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__are_equal(
      &(lhs->max_arrival_time), &(rhs->max_arrival_time)))
  {
    return false;
  }
  // min_velocity
  if (!etsi_its_mcm_uulm_msgs__msg__SpeedValue__are_equal(
      &(lhs->min_velocity), &(rhs->min_velocity)))
  {
    return false;
  }
  // min_velocity_is_present
  if (lhs->min_velocity_is_present != rhs->min_velocity_is_present) {
    return false;
  }
  // max_velocity
  if (!etsi_its_mcm_uulm_msgs__msg__SpeedValue__are_equal(
      &(lhs->max_velocity), &(rhs->max_velocity)))
  {
    return false;
  }
  // max_velocity_is_present
  if (lhs->max_velocity_is_present != rhs->max_velocity_is_present) {
    return false;
  }
  // min_duration_of_stop
  if (!etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__are_equal(
      &(lhs->min_duration_of_stop), &(rhs->min_duration_of_stop)))
  {
    return false;
  }
  // min_duration_of_stop_is_present
  if (lhs->min_duration_of_stop_is_present != rhs->min_duration_of_stop_is_present) {
    return false;
  }
  // preceding_road_user
  if (!etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIndex__are_equal(
      &(lhs->preceding_road_user), &(rhs->preceding_road_user)))
  {
    return false;
  }
  // preceding_road_user_is_present
  if (lhs->preceding_road_user_is_present != rhs->preceding_road_user_is_present) {
    return false;
  }
  // following_road_user
  if (!etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIndex__are_equal(
      &(lhs->following_road_user), &(rhs->following_road_user)))
  {
    return false;
  }
  // following_road_user_is_present
  if (lhs->following_road_user_is_present != rhs->following_road_user_is_present) {
    return false;
  }
  // yield_to_road_user_container
  if (!etsi_its_mcm_uulm_msgs__msg__YieldToRoadUserContainer__are_equal(
      &(lhs->yield_to_road_user_container), &(rhs->yield_to_road_user_container)))
  {
    return false;
  }
  // yield_to_road_user_container_is_present
  if (lhs->yield_to_road_user_container_is_present != rhs->yield_to_road_user_container_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__copy(
  const etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * input,
  etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * output)
{
  if (!input || !output) {
    return false;
  }
  // waypoint
  if (!etsi_its_mcm_uulm_msgs__msg__Waypoint__copy(
      &(input->waypoint), &(output->waypoint)))
  {
    return false;
  }
  // min_arrival_time
  if (!etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__copy(
      &(input->min_arrival_time), &(output->min_arrival_time)))
  {
    return false;
  }
  // max_arrival_time
  if (!etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__copy(
      &(input->max_arrival_time), &(output->max_arrival_time)))
  {
    return false;
  }
  // min_velocity
  if (!etsi_its_mcm_uulm_msgs__msg__SpeedValue__copy(
      &(input->min_velocity), &(output->min_velocity)))
  {
    return false;
  }
  // min_velocity_is_present
  output->min_velocity_is_present = input->min_velocity_is_present;
  // max_velocity
  if (!etsi_its_mcm_uulm_msgs__msg__SpeedValue__copy(
      &(input->max_velocity), &(output->max_velocity)))
  {
    return false;
  }
  // max_velocity_is_present
  output->max_velocity_is_present = input->max_velocity_is_present;
  // min_duration_of_stop
  if (!etsi_its_mcm_uulm_msgs__msg__WaypointDeltaTime__copy(
      &(input->min_duration_of_stop), &(output->min_duration_of_stop)))
  {
    return false;
  }
  // min_duration_of_stop_is_present
  output->min_duration_of_stop_is_present = input->min_duration_of_stop_is_present;
  // preceding_road_user
  if (!etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIndex__copy(
      &(input->preceding_road_user), &(output->preceding_road_user)))
  {
    return false;
  }
  // preceding_road_user_is_present
  output->preceding_road_user_is_present = input->preceding_road_user_is_present;
  // following_road_user
  if (!etsi_its_mcm_uulm_msgs__msg__ParticipatingRoadUserIndex__copy(
      &(input->following_road_user), &(output->following_road_user)))
  {
    return false;
  }
  // following_road_user_is_present
  output->following_road_user_is_present = input->following_road_user_is_present;
  // yield_to_road_user_container
  if (!etsi_its_mcm_uulm_msgs__msg__YieldToRoadUserContainer__copy(
      &(input->yield_to_road_user_container), &(output->yield_to_road_user_container)))
  {
    return false;
  }
  // yield_to_road_user_container_is_present
  output->yield_to_road_user_container_is_present = input->yield_to_road_user_container_is_present;
  return true;
}

etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint *
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * msg = (etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint));
  bool success = etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__destroy(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence__init(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * data = NULL;

  if (size) {
    data = (etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint *)allocator.zero_allocate(size, sizeof(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence__fini(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence *
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence * array = (etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence__destroy(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence__are_equal(const etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence * lhs, const etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence__copy(
  const etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence * input,
  etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint * data =
      (etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__LongitudinalWaypoint__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
