// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/LongitudinalWaypoint.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__LONGITUDINAL_WAYPOINT__TRAITS_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__LONGITUDINAL_WAYPOINT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mcm_uulm_msgs/msg/detail/longitudinal_waypoint__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'waypoint'
#include "etsi_its_mcm_uulm_msgs/msg/detail/waypoint__traits.hpp"
// Member 'min_arrival_time'
// Member 'max_arrival_time'
// Member 'min_duration_of_stop'
#include "etsi_its_mcm_uulm_msgs/msg/detail/waypoint_delta_time__traits.hpp"
// Member 'min_velocity'
// Member 'max_velocity'
#include "etsi_its_mcm_uulm_msgs/msg/detail/speed_value__traits.hpp"
// Member 'preceding_road_user'
// Member 'following_road_user'
#include "etsi_its_mcm_uulm_msgs/msg/detail/participating_road_user_index__traits.hpp"
// Member 'yield_to_road_user_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/yield_to_road_user_container__traits.hpp"

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const LongitudinalWaypoint & msg,
  std::ostream & out)
{
  out << "{";
  // member: waypoint
  {
    out << "waypoint: ";
    to_flow_style_yaml(msg.waypoint, out);
    out << ", ";
  }

  // member: min_arrival_time
  {
    out << "min_arrival_time: ";
    to_flow_style_yaml(msg.min_arrival_time, out);
    out << ", ";
  }

  // member: max_arrival_time
  {
    out << "max_arrival_time: ";
    to_flow_style_yaml(msg.max_arrival_time, out);
    out << ", ";
  }

  // member: min_velocity
  {
    out << "min_velocity: ";
    to_flow_style_yaml(msg.min_velocity, out);
    out << ", ";
  }

  // member: min_velocity_is_present
  {
    out << "min_velocity_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.min_velocity_is_present, out);
    out << ", ";
  }

  // member: max_velocity
  {
    out << "max_velocity: ";
    to_flow_style_yaml(msg.max_velocity, out);
    out << ", ";
  }

  // member: max_velocity_is_present
  {
    out << "max_velocity_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.max_velocity_is_present, out);
    out << ", ";
  }

  // member: min_duration_of_stop
  {
    out << "min_duration_of_stop: ";
    to_flow_style_yaml(msg.min_duration_of_stop, out);
    out << ", ";
  }

  // member: min_duration_of_stop_is_present
  {
    out << "min_duration_of_stop_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.min_duration_of_stop_is_present, out);
    out << ", ";
  }

  // member: preceding_road_user
  {
    out << "preceding_road_user: ";
    to_flow_style_yaml(msg.preceding_road_user, out);
    out << ", ";
  }

  // member: preceding_road_user_is_present
  {
    out << "preceding_road_user_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.preceding_road_user_is_present, out);
    out << ", ";
  }

  // member: following_road_user
  {
    out << "following_road_user: ";
    to_flow_style_yaml(msg.following_road_user, out);
    out << ", ";
  }

  // member: following_road_user_is_present
  {
    out << "following_road_user_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.following_road_user_is_present, out);
    out << ", ";
  }

  // member: yield_to_road_user_container
  {
    out << "yield_to_road_user_container: ";
    to_flow_style_yaml(msg.yield_to_road_user_container, out);
    out << ", ";
  }

  // member: yield_to_road_user_container_is_present
  {
    out << "yield_to_road_user_container_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.yield_to_road_user_container_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const LongitudinalWaypoint & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: waypoint
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "waypoint:\n";
    to_block_style_yaml(msg.waypoint, out, indentation + 2);
  }

  // member: min_arrival_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_arrival_time:\n";
    to_block_style_yaml(msg.min_arrival_time, out, indentation + 2);
  }

  // member: max_arrival_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_arrival_time:\n";
    to_block_style_yaml(msg.max_arrival_time, out, indentation + 2);
  }

  // member: min_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_velocity:\n";
    to_block_style_yaml(msg.min_velocity, out, indentation + 2);
  }

  // member: min_velocity_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_velocity_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.min_velocity_is_present, out);
    out << "\n";
  }

  // member: max_velocity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_velocity:\n";
    to_block_style_yaml(msg.max_velocity, out, indentation + 2);
  }

  // member: max_velocity_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "max_velocity_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.max_velocity_is_present, out);
    out << "\n";
  }

  // member: min_duration_of_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_duration_of_stop:\n";
    to_block_style_yaml(msg.min_duration_of_stop, out, indentation + 2);
  }

  // member: min_duration_of_stop_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "min_duration_of_stop_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.min_duration_of_stop_is_present, out);
    out << "\n";
  }

  // member: preceding_road_user
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "preceding_road_user:\n";
    to_block_style_yaml(msg.preceding_road_user, out, indentation + 2);
  }

  // member: preceding_road_user_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "preceding_road_user_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.preceding_road_user_is_present, out);
    out << "\n";
  }

  // member: following_road_user
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "following_road_user:\n";
    to_block_style_yaml(msg.following_road_user, out, indentation + 2);
  }

  // member: following_road_user_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "following_road_user_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.following_road_user_is_present, out);
    out << "\n";
  }

  // member: yield_to_road_user_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yield_to_road_user_container:\n";
    to_block_style_yaml(msg.yield_to_road_user_container, out, indentation + 2);
  }

  // member: yield_to_road_user_container_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yield_to_road_user_container_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.yield_to_road_user_container_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const LongitudinalWaypoint & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint & msg)
{
  return etsi_its_mcm_uulm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint>()
{
  return "etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint";
}

template<>
inline const char * name<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint>()
{
  return "etsi_its_mcm_uulm_msgs/msg/LongitudinalWaypoint";
}

template<>
struct has_fixed_size<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mcm_uulm_msgs::msg::ParticipatingRoadUserIndex>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::SpeedValue>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::Waypoint>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::WaypointDeltaTime>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::YieldToRoadUserContainer>::value> {};

template<>
struct has_bounded_size<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mcm_uulm_msgs::msg::ParticipatingRoadUserIndex>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::SpeedValue>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::Waypoint>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::WaypointDeltaTime>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::YieldToRoadUserContainer>::value> {};

template<>
struct is_message<etsi_its_mcm_uulm_msgs::msg::LongitudinalWaypoint>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__LONGITUDINAL_WAYPOINT__TRAITS_HPP_
