// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/ManeuverCoordinationMessage.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_COORDINATION_MESSAGE__STRUCT_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_COORDINATION_MESSAGE__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'generation_delta_time'
#include "etsi_its_mcm_uulm_msgs/msg/detail/generation_delta_time__struct.hpp"
// Member 'mcm_parameters'
#include "etsi_its_mcm_uulm_msgs/msg/detail/mcm_parameters__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverCoordinationMessage __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverCoordinationMessage __declspec(deprecated)
#endif

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ManeuverCoordinationMessage_
{
  using Type = ManeuverCoordinationMessage_<ContainerAllocator>;

  explicit ManeuverCoordinationMessage_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : generation_delta_time(_init),
    mcm_parameters(_init)
  {
    (void)_init;
  }

  explicit ManeuverCoordinationMessage_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : generation_delta_time(_alloc, _init),
    mcm_parameters(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _generation_delta_time_type =
    etsi_its_mcm_uulm_msgs::msg::GenerationDeltaTime_<ContainerAllocator>;
  _generation_delta_time_type generation_delta_time;
  using _mcm_parameters_type =
    etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator>;
  _mcm_parameters_type mcm_parameters;

  // setters for named parameter idiom
  Type & set__generation_delta_time(
    const etsi_its_mcm_uulm_msgs::msg::GenerationDeltaTime_<ContainerAllocator> & _arg)
  {
    this->generation_delta_time = _arg;
    return *this;
  }
  Type & set__mcm_parameters(
    const etsi_its_mcm_uulm_msgs::msg::McmParameters_<ContainerAllocator> & _arg)
  {
    this->mcm_parameters = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverCoordinationMessage
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_mcm_uulm_msgs__msg__ManeuverCoordinationMessage
    std::shared_ptr<etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ManeuverCoordinationMessage_ & other) const
  {
    if (this->generation_delta_time != other.generation_delta_time) {
      return false;
    }
    if (this->mcm_parameters != other.mcm_parameters) {
      return false;
    }
    return true;
  }
  bool operator!=(const ManeuverCoordinationMessage_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ManeuverCoordinationMessage_

// alias to use template instance with default allocator
using ManeuverCoordinationMessage =
  etsi_its_mcm_uulm_msgs::msg::ManeuverCoordinationMessage_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__MANEUVER_COORDINATION_MESSAGE__STRUCT_HPP_
