// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mcm_uulm_msgs:msg/RoadUserContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `road_user_state`
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_state__functions.h"
// Member `planned_trajectory`
#include "etsi_its_mcm_uulm_msgs/msg/detail/planned_trajectory__functions.h"
// Member `desired_route`
#include "etsi_its_mcm_uulm_msgs/msg/detail/desired_route__functions.h"
// Member `advice_response`
#include "etsi_its_mcm_uulm_msgs/msg/detail/advice_response__functions.h"

bool
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__init(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer * msg)
{
  if (!msg) {
    return false;
  }
  // road_user_state
  if (!etsi_its_mcm_uulm_msgs__msg__RoadUserState__init(&msg->road_user_state)) {
    etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__fini(msg);
    return false;
  }
  // planned_trajectory
  if (!etsi_its_mcm_uulm_msgs__msg__PlannedTrajectory__init(&msg->planned_trajectory)) {
    etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__fini(msg);
    return false;
  }
  // planned_trajectory_is_present
  // desired_route
  if (!etsi_its_mcm_uulm_msgs__msg__DesiredRoute__init(&msg->desired_route)) {
    etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__fini(msg);
    return false;
  }
  // desired_route_is_present
  // advice_response
  if (!etsi_its_mcm_uulm_msgs__msg__AdviceResponse__init(&msg->advice_response)) {
    etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__fini(msg);
    return false;
  }
  // advice_response_is_present
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__fini(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer * msg)
{
  if (!msg) {
    return;
  }
  // road_user_state
  etsi_its_mcm_uulm_msgs__msg__RoadUserState__fini(&msg->road_user_state);
  // planned_trajectory
  etsi_its_mcm_uulm_msgs__msg__PlannedTrajectory__fini(&msg->planned_trajectory);
  // planned_trajectory_is_present
  // desired_route
  etsi_its_mcm_uulm_msgs__msg__DesiredRoute__fini(&msg->desired_route);
  // desired_route_is_present
  // advice_response
  etsi_its_mcm_uulm_msgs__msg__AdviceResponse__fini(&msg->advice_response);
  // advice_response_is_present
}

bool
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__are_equal(const etsi_its_mcm_uulm_msgs__msg__RoadUserContainer * lhs, const etsi_its_mcm_uulm_msgs__msg__RoadUserContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // road_user_state
  if (!etsi_its_mcm_uulm_msgs__msg__RoadUserState__are_equal(
      &(lhs->road_user_state), &(rhs->road_user_state)))
  {
    return false;
  }
  // planned_trajectory
  if (!etsi_its_mcm_uulm_msgs__msg__PlannedTrajectory__are_equal(
      &(lhs->planned_trajectory), &(rhs->planned_trajectory)))
  {
    return false;
  }
  // planned_trajectory_is_present
  if (lhs->planned_trajectory_is_present != rhs->planned_trajectory_is_present) {
    return false;
  }
  // desired_route
  if (!etsi_its_mcm_uulm_msgs__msg__DesiredRoute__are_equal(
      &(lhs->desired_route), &(rhs->desired_route)))
  {
    return false;
  }
  // desired_route_is_present
  if (lhs->desired_route_is_present != rhs->desired_route_is_present) {
    return false;
  }
  // advice_response
  if (!etsi_its_mcm_uulm_msgs__msg__AdviceResponse__are_equal(
      &(lhs->advice_response), &(rhs->advice_response)))
  {
    return false;
  }
  // advice_response_is_present
  if (lhs->advice_response_is_present != rhs->advice_response_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__copy(
  const etsi_its_mcm_uulm_msgs__msg__RoadUserContainer * input,
  etsi_its_mcm_uulm_msgs__msg__RoadUserContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // road_user_state
  if (!etsi_its_mcm_uulm_msgs__msg__RoadUserState__copy(
      &(input->road_user_state), &(output->road_user_state)))
  {
    return false;
  }
  // planned_trajectory
  if (!etsi_its_mcm_uulm_msgs__msg__PlannedTrajectory__copy(
      &(input->planned_trajectory), &(output->planned_trajectory)))
  {
    return false;
  }
  // planned_trajectory_is_present
  output->planned_trajectory_is_present = input->planned_trajectory_is_present;
  // desired_route
  if (!etsi_its_mcm_uulm_msgs__msg__DesiredRoute__copy(
      &(input->desired_route), &(output->desired_route)))
  {
    return false;
  }
  // desired_route_is_present
  output->desired_route_is_present = input->desired_route_is_present;
  // advice_response
  if (!etsi_its_mcm_uulm_msgs__msg__AdviceResponse__copy(
      &(input->advice_response), &(output->advice_response)))
  {
    return false;
  }
  // advice_response_is_present
  output->advice_response_is_present = input->advice_response_is_present;
  return true;
}

etsi_its_mcm_uulm_msgs__msg__RoadUserContainer *
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__RoadUserContainer * msg = (etsi_its_mcm_uulm_msgs__msg__RoadUserContainer *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer));
  bool success = etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__destroy(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence__init(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__RoadUserContainer * data = NULL;

  if (size) {
    data = (etsi_its_mcm_uulm_msgs__msg__RoadUserContainer *)allocator.zero_allocate(size, sizeof(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence__fini(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence *
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence * array = (etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence__destroy(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence__are_equal(const etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence * lhs, const etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence__copy(
  const etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence * input,
  etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mcm_uulm_msgs__msg__RoadUserContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mcm_uulm_msgs__msg__RoadUserContainer * data =
      (etsi_its_mcm_uulm_msgs__msg__RoadUserContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__RoadUserContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
