// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/RoadUserState.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_STATE__TRAITS_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_STATE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_state__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'road_user_type'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_type__traits.hpp"
// Member 'speed'
#include "etsi_its_mcm_uulm_msgs/msg/detail/speed_value__traits.hpp"
// Member 'heading'
#include "etsi_its_mcm_uulm_msgs/msg/detail/heading_value__traits.hpp"
// Member 'length'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_length__traits.hpp"
// Member 'width'
#include "etsi_its_mcm_uulm_msgs/msg/detail/road_user_width__traits.hpp"

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RoadUserState & msg,
  std::ostream & out)
{
  out << "{";
  // member: road_user_type
  {
    out << "road_user_type: ";
    to_flow_style_yaml(msg.road_user_type, out);
    out << ", ";
  }

  // member: speed
  {
    out << "speed: ";
    to_flow_style_yaml(msg.speed, out);
    out << ", ";
  }

  // member: heading
  {
    out << "heading: ";
    to_flow_style_yaml(msg.heading, out);
    out << ", ";
  }

  // member: length
  {
    out << "length: ";
    to_flow_style_yaml(msg.length, out);
    out << ", ";
  }

  // member: width
  {
    out << "width: ";
    to_flow_style_yaml(msg.width, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RoadUserState & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: road_user_type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "road_user_type:\n";
    to_block_style_yaml(msg.road_user_type, out, indentation + 2);
  }

  // member: speed
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "speed:\n";
    to_block_style_yaml(msg.speed, out, indentation + 2);
  }

  // member: heading
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "heading:\n";
    to_block_style_yaml(msg.heading, out, indentation + 2);
  }

  // member: length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "length:\n";
    to_block_style_yaml(msg.length, out, indentation + 2);
  }

  // member: width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "width:\n";
    to_block_style_yaml(msg.width, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RoadUserState & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mcm_uulm_msgs::msg::RoadUserState & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mcm_uulm_msgs::msg::RoadUserState & msg)
{
  return etsi_its_mcm_uulm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mcm_uulm_msgs::msg::RoadUserState>()
{
  return "etsi_its_mcm_uulm_msgs::msg::RoadUserState";
}

template<>
inline const char * name<etsi_its_mcm_uulm_msgs::msg::RoadUserState>()
{
  return "etsi_its_mcm_uulm_msgs/msg/RoadUserState";
}

template<>
struct has_fixed_size<etsi_its_mcm_uulm_msgs::msg::RoadUserState>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mcm_uulm_msgs::msg::HeadingValue>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::RoadUserLength>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::RoadUserType>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::RoadUserWidth>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::SpeedValue>::value> {};

template<>
struct has_bounded_size<etsi_its_mcm_uulm_msgs::msg::RoadUserState>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mcm_uulm_msgs::msg::HeadingValue>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::RoadUserLength>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::RoadUserType>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::RoadUserWidth>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::SpeedValue>::value> {};

template<>
struct is_message<etsi_its_mcm_uulm_msgs::msg::RoadUserState>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__ROAD_USER_STATE__TRAITS_HPP_
