// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/SuggestedManeuver.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER__TRAITS_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mcm_uulm_msgs/msg/detail/suggested_maneuver__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'maneuver_id'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_id__traits.hpp"
// Member 'advice_update_id'
#include "etsi_its_mcm_uulm_msgs/msg/detail/advice_update_id__traits.hpp"
// Member 'participating_road_user_id_container'
#include "etsi_its_mcm_uulm_msgs/msg/detail/participating_road_user_id_container__traits.hpp"
// Member 'confirmation_required_flag'
#include "etsi_its_mcm_uulm_msgs/msg/detail/confirmation_required_flag__traits.hpp"
// Member 'maneuver_parameters'
#include "etsi_its_mcm_uulm_msgs/msg/detail/maneuver_parameters__traits.hpp"

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SuggestedManeuver & msg,
  std::ostream & out)
{
  out << "{";
  // member: maneuver_id
  {
    out << "maneuver_id: ";
    to_flow_style_yaml(msg.maneuver_id, out);
    out << ", ";
  }

  // member: advice_update_id
  {
    out << "advice_update_id: ";
    to_flow_style_yaml(msg.advice_update_id, out);
    out << ", ";
  }

  // member: participating_road_user_id_container
  {
    out << "participating_road_user_id_container: ";
    to_flow_style_yaml(msg.participating_road_user_id_container, out);
    out << ", ";
  }

  // member: confirmation_required_flag
  {
    out << "confirmation_required_flag: ";
    to_flow_style_yaml(msg.confirmation_required_flag, out);
    out << ", ";
  }

  // member: maneuver_parameters
  {
    out << "maneuver_parameters: ";
    to_flow_style_yaml(msg.maneuver_parameters, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SuggestedManeuver & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: maneuver_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuver_id:\n";
    to_block_style_yaml(msg.maneuver_id, out, indentation + 2);
  }

  // member: advice_update_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "advice_update_id:\n";
    to_block_style_yaml(msg.advice_update_id, out, indentation + 2);
  }

  // member: participating_road_user_id_container
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "participating_road_user_id_container:\n";
    to_block_style_yaml(msg.participating_road_user_id_container, out, indentation + 2);
  }

  // member: confirmation_required_flag
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "confirmation_required_flag:\n";
    to_block_style_yaml(msg.confirmation_required_flag, out, indentation + 2);
  }

  // member: maneuver_parameters
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "maneuver_parameters:\n";
    to_block_style_yaml(msg.maneuver_parameters, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SuggestedManeuver & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver & msg)
{
  return etsi_its_mcm_uulm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver>()
{
  return "etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver";
}

template<>
inline const char * name<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver>()
{
  return "etsi_its_mcm_uulm_msgs/msg/SuggestedManeuver";
}

template<>
struct has_fixed_size<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mcm_uulm_msgs::msg::AdviceUpdateID>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::ConfirmationRequiredFlag>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::ManeuverID>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::ManeuverParameters>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::ParticipatingRoadUserIDContainer>::value> {};

template<>
struct has_bounded_size<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mcm_uulm_msgs::msg::AdviceUpdateID>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::ConfirmationRequiredFlag>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::ManeuverID>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::ManeuverParameters>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::ParticipatingRoadUserIDContainer>::value> {};

template<>
struct is_message<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER__TRAITS_HPP_
