// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_mcm_uulm_msgs:msg/SuggestedManeuverContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_mcm_uulm_msgs/msg/detail/suggested_maneuver_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `target_station_id`
#include "etsi_its_mcm_uulm_msgs/msg/detail/station_id__functions.h"
// Member `suggested_maneuver`
#include "etsi_its_mcm_uulm_msgs/msg/detail/suggested_maneuver__functions.h"

bool
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__init(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer * msg)
{
  if (!msg) {
    return false;
  }
  // target_station_id
  if (!etsi_its_mcm_uulm_msgs__msg__StationId__init(&msg->target_station_id)) {
    etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__fini(msg);
    return false;
  }
  // suggested_maneuver
  if (!etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver__init(&msg->suggested_maneuver)) {
    etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__fini(msg);
    return false;
  }
  // suggested_maneuver_is_present
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__fini(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer * msg)
{
  if (!msg) {
    return;
  }
  // target_station_id
  etsi_its_mcm_uulm_msgs__msg__StationId__fini(&msg->target_station_id);
  // suggested_maneuver
  etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver__fini(&msg->suggested_maneuver);
  // suggested_maneuver_is_present
}

bool
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__are_equal(const etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer * lhs, const etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // target_station_id
  if (!etsi_its_mcm_uulm_msgs__msg__StationId__are_equal(
      &(lhs->target_station_id), &(rhs->target_station_id)))
  {
    return false;
  }
  // suggested_maneuver
  if (!etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver__are_equal(
      &(lhs->suggested_maneuver), &(rhs->suggested_maneuver)))
  {
    return false;
  }
  // suggested_maneuver_is_present
  if (lhs->suggested_maneuver_is_present != rhs->suggested_maneuver_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__copy(
  const etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer * input,
  etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // target_station_id
  if (!etsi_its_mcm_uulm_msgs__msg__StationId__copy(
      &(input->target_station_id), &(output->target_station_id)))
  {
    return false;
  }
  // suggested_maneuver
  if (!etsi_its_mcm_uulm_msgs__msg__SuggestedManeuver__copy(
      &(input->suggested_maneuver), &(output->suggested_maneuver)))
  {
    return false;
  }
  // suggested_maneuver_is_present
  output->suggested_maneuver_is_present = input->suggested_maneuver_is_present;
  return true;
}

etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer *
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer * msg = (etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer));
  bool success = etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__destroy(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence__init(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer * data = NULL;

  if (size) {
    data = (etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer *)allocator.zero_allocate(size, sizeof(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence__fini(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence *
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence * array = (etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence *)allocator.allocate(sizeof(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence__destroy(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence__are_equal(const etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence * lhs, const etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence__copy(
  const etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence * input,
  etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer * data =
      (etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_mcm_uulm_msgs__msg__SuggestedManeuverContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
