// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_mcm_uulm_msgs:msg/SuggestedManeuverContainer.idl
// generated code does not contain a copyright notice

#ifndef ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER_CONTAINER__TRAITS_HPP_
#define ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER_CONTAINER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_mcm_uulm_msgs/msg/detail/suggested_maneuver_container__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'target_station_id'
#include "etsi_its_mcm_uulm_msgs/msg/detail/station_id__traits.hpp"
// Member 'suggested_maneuver'
#include "etsi_its_mcm_uulm_msgs/msg/detail/suggested_maneuver__traits.hpp"

namespace etsi_its_mcm_uulm_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SuggestedManeuverContainer & msg,
  std::ostream & out)
{
  out << "{";
  // member: target_station_id
  {
    out << "target_station_id: ";
    to_flow_style_yaml(msg.target_station_id, out);
    out << ", ";
  }

  // member: suggested_maneuver
  {
    out << "suggested_maneuver: ";
    to_flow_style_yaml(msg.suggested_maneuver, out);
    out << ", ";
  }

  // member: suggested_maneuver_is_present
  {
    out << "suggested_maneuver_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.suggested_maneuver_is_present, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SuggestedManeuverContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: target_station_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "target_station_id:\n";
    to_block_style_yaml(msg.target_station_id, out, indentation + 2);
  }

  // member: suggested_maneuver
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "suggested_maneuver:\n";
    to_block_style_yaml(msg.suggested_maneuver, out, indentation + 2);
  }

  // member: suggested_maneuver_is_present
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "suggested_maneuver_is_present: ";
    rosidl_generator_traits::value_to_yaml(msg.suggested_maneuver_is_present, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SuggestedManeuverContainer & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_mcm_uulm_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_mcm_uulm_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_mcm_uulm_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer & msg)
{
  return etsi_its_mcm_uulm_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer>()
{
  return "etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer";
}

template<>
inline const char * name<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer>()
{
  return "etsi_its_mcm_uulm_msgs/msg/SuggestedManeuverContainer";
}

template<>
struct has_fixed_size<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer>
  : std::integral_constant<bool, has_fixed_size<etsi_its_mcm_uulm_msgs::msg::StationId>::value && has_fixed_size<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver>::value> {};

template<>
struct has_bounded_size<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer>
  : std::integral_constant<bool, has_bounded_size<etsi_its_mcm_uulm_msgs::msg::StationId>::value && has_bounded_size<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuver>::value> {};

template<>
struct is_message<etsi_its_mcm_uulm_msgs::msg::SuggestedManeuverContainer>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_MCM_UULM_MSGS__MSG__DETAIL__SUGGESTED_MANEUVER_CONTAINER__TRAITS_HPP_
